#!/usr/bin/python3

import msgpack
import ipaddress
import sys
import os
import redis

ip = ipaddress.ip_address(sys.argv[1])
ipi = int(ip)

r = redis.Redis(host="localhost", port=6379, decode_responses=True)

country = r.get(f"geoip_{ipi}")
if country:
	print(country)
	sys.exit()

pth = os.path.dirname(os.path.realpath(__file__))
with open(os.path.join(pth, "geoip_country.mp"), "rb") as f:
	geoip = msgpack.unpack(f)

for start, end, country in geoip:
	if ipi >= start and ipi <= end:
		r.setex(f"geoip_{ipi}", 300, country)
		print(country)
		break
